// --------------------------------------------------------------------------
// Scadenzario
// fv 24/8/94
// --------------------------------------------------------------------------

#include <sheet.h>

#include "cg2102.h"
#include "cg2100.h"
#include "cg21sld.h"
#include "pagament.h"

#include <partite.h>
#include <scadenze.h>

bool TPrimanota_application::pag_notify(int r, KEY k)
{                                                          
  TPagamento&    pag = app().pagamento();
  TSheet_field&  ps  = app().pags(); 
  TMask*         msk = &(app().curr_mask());      
  TString_array& rws = app().pag_rows();                                
  
  int rdiff = atoi(msk->get(FS_RDIFFER));
  
  // ts contiene la vecchia riga, ns la nuova                                       
  TToken_string ts(36), ns(36);

  bool doit = TRUE, m_imp = FALSE, m_perc = FALSE, m_pag = FALSE;
  bool m_scad = FALSE, m_tipo = FALSE, mod = FALSE;
  word ahiahi = P_OK;                                
  
  TString news(15), newi(15), newp(15), newt(2);                                  

  bool recalc = msk->get_bool(FS_RECALC); 
  bool mcomm  = msk->get_bool(FS_MCOMM);
  
  switch (k)
  {
  case K_SPACE:
    break;
  case K_ENTER:
    ns  = ps.row(r);     
    ts  = rws.row(r);    
    
    news = ns.get(0);
    newp = ns.get(1);
    newi = ns.get(2);
    newt = ns.get(3);                                            
    
    // qui viene il bello, si fa per dire 
    if (news != ts.get(0))  // modificata data scadenza
    {                            
      mod  = m_scad = TRUE;        
    }
    if (newp != ts.get(1))  // modificata percentuale
    {                
      mod  = m_perc = TRUE;        
    }
    if (newi != ts.get(2))  // modificato importo
    {          
       // se si modifica la percentuale l'importo non viene cagato
      if ((recalc && !m_perc) || (!recalc)) 
      {
        mod  = m_imp = TRUE;   
      }
    }
    if (newt != ts.get(3))  // modificato tipo pagamento
    {                 
      mod = m_tipo  = TRUE;      
    }
    break;
  case K_DEL:
  case K_INS:
    doit = FALSE;
    break;
  default:
    break;
  }          
  

  // settato da recalc_rate se occorre ridefinire lo sheet
  // aggiungendo o togliendo righe
  bool need_recalc = FALSE;      

  if (k == K_ENTER) 
  {
    if (mod && recalc)
    {
      // ricalcola sheet come sai fare tu
      ahiahi = pag.recalc_rate(r, m_perc, 
                               ((m_perc || m_imp) ? 
                                (m_perc ? (const char*)newp : (const char*)newi) : 
                                NULL), 
                               (m_scad ? (const char*)news : NULL),
                               (m_tipo ? (const char*)newt : NULL), 
                               rdiff, mcomm, need_recalc);
      // see if rdiff changed                          
      msk->field(FS_RDIFFER).set(pag.rate_differenziate() ? "1" : "2");
    }
    if (!recalc)
    {                              
      ahiahi = P_OK;
      // put data as they are
      TToken_string& trw = pag.rata(r);
      TToken_string  srw = trw;
      if (m_scad)  trw.add(news,3);
      if (m_perc)  trw.add(newp,1);
      if (m_imp)   trw.add(newi,4);
      if (m_tipo)  trw.add(newt,2);
      // validate the payment
      if ((ahiahi = pag.validate()) != P_OK)
        pag.rata(r) = srw;
    }
    if (ahiahi)  // any error? Rimetti le righe com'erano prima
    {  
      beep(); 
      
      // se gli errori sono voluti, spiegali
      if (!recalc)
      {                    
        TString256 s;
        pag.strerr(ahiahi,s);
        warning_box(s);
      }
      
      ps.row(r) = rws.row(r); 
      ps.force_update(r); 
    } 
    
    else if (recalc && mod && need_recalc) 
    {                                   
      // ridefinisci lo sheet sulla base delle nuove rate
      pag.set_sheet(ps);
      ps.force_update();         
      rws = ps.rows_array();      
    } 
  }
  
  return doit;
}                            

bool TPrimanota_application::codpag_handler(TMask_field& f, KEY key)
{                                 
  TMask& m = f.mask();
  
  if (key == K_TAB && (f.focusdirty() || !m.is_running()) && app().is_saldaconto())
  {
    const TString16 dt(m.get(F_DATAREG));
    app().set_pagamento(f.get(), dt);     
    app().set_scadenze(m);
  }
  return TRUE;
}
                           
void TPrimanota_application::set_pagamento(const char* c, const char* d)
{ 
  if (_pag != NULL) delete _pag;
  _pag = new TPagamento(c,d);
} 

void TPrimanota_application::set_scadenze(TMask& m)
{                                                                  
  real      imponibile(0.0);   
  real      imposta(0.0);   
  real      spese(0.0);        
          
  TPagamento& pag = pagamento();        
  
  if (pag.is_new()) 
  {        
    m.disable_page(2);
    return;
  }
  else m.enable_page(2);

  m.set(FS_RDIFFER, pag.rate_differenziate() ? "1" : "2");
  m.set(FS_NAMEPAG, pag.name());
  m.set(FS_TIPOPR, pag.desc_tpr());
  m.set(FS_MCOMM, pag.mese_commerciale() ? "X" : "");
  
  TSheet_field& iva_sh = ivas();
  
  for (int i = 0; i < iva_sh.items(); i++)
  {
    TToken_string& tt = iva_sh.row(i);
    const real mpo(tt.get(0)); 
    imponibile += mpo;
    const real imp(tt.get(3));
    imposta    += imp;
  }                    
  
  m.set(FS_IMPONIBILE, imponibile.string());
  m.set(FS_IMPOSTA, imposta.string());
  m.set(FS_SPESE, spese.string());
  m.set(FS_RECALC, "X");

  pag.set_total(imponibile, imposta, spese);                              
  pag.set_rate_auto();          
  bool new_part = TRUE; 
  
  TSheet_field& ps = (TSheet_field&)m.field(FS_RATESHEET);

  // prepara lo sheet
  pag.set_sheet(ps);
  _pag_rows = ps.rows_array();

  // se la prima rata e' fissa non si tocca
  if (pag.tipo_prima_rata() > 0)
  {
    ps.disable_cell(0,0);
    ps.disable_cell(0,1);
    ps.disable_cell(0,2);
    ps.disable_cell(0,3);
  }              
}

bool TPrimanota_application::read_scadenze(const TMask& m)
{                                                                  
  real      imponibile(0.0);   
  real      imposta(0.0);   
  real      spese(0.0);        

  TSheet_field& ps = (TSheet_field&)m.field(FS_RATESHEET);

  // should never happen but it doesn't hurt
  if (_rel->cg(0).empty()) return FALSE; 

  TSheet_field& iva_sh = ivas();
  
  for (int i = 0; i < iva_sh.items(); i++)
  {
    TToken_string& tt = iva_sh.row(i);
    real mpo(tt.get(0)); 
    real imp(tt.get(3));
    imponibile += mpo;
    imposta    += imp;
  }                    
  
  m.field(FS_IMPONIBILE).set(imponibile.string());
  m.field(FS_IMPOSTA).set(imposta.string());
  m.field(FS_SPESE).set(spese.string());
  m.field(FS_RECALC).set("X");
  
  TPagamento& pag = pagamento();
  pag.set_total(imponibile, imposta, spese);                              

  TLocalisamfile partita (LF_PARTITE);
  TLocalisamfile scadenza(LF_SCADENZE);
  
  TString nreg(_rel->lfile().get("NUMREG"));
  TString ndoc(_rel->lfile().get("NUMDOC"));
  TString tmov(_rel->lfile().get("TIPOMOV"));
  TDate   ddoc(_rel->lfile().get_date("DATADOC"));
  TDate   dreg(_rel->lfile().get_date("DATAREG"));                                    
  TString reg (_rel->lfile().get("REG")); 
  TString protiva(_rel->lfile().get("PROTIVA")); 
  TString codcaus(_rel->lfile().get("CODCAUS")); 
  TString codval (_rel->lfile().get("CODVAL")); 
  TString cambio (_rel->lfile().get("CAMBIO")); 
  
  TString numpart = m.get(F_NUMRIF);
  TString anno    = m.get(F_ANNORIF);
  
  char sezione    = _rel->cg(0).get_char("SEZIONE"); // Dare/Avere
  char tipocf     = _rel->cg(0).get_char("TIPOC"); // Cliente || Fornitore || Uncazzo
  int  gruppo     = (tipocf == 'C' || tipocf == 'F') ? 0 : _rel->cg(0).get_char("GRUPPO");
  int  conto      = (tipocf == 'C' || tipocf == 'F') ? 0 : _rel->cg(0).get_char("CONTO");
  long sottoconto = _rel->cg(0).get_long("SOTTOCONTO");
  int  nriga      = 1;
  int  numrig     = 1;
  
//  partita.put("TIPOCF",     tipocf);
//  partita.put("GRUPPO",     gruppo);
//  partita.put("CONTO",      conto);
//  partita.put("SOTTOCONTO", sottoconto);
  partita.put(PART_ANNO,    anno);
  partita.put(PART_NUMPART, numpart);
  partita.put(PART_NRIGA,   nriga);
  
  bool fromscratch = FALSE;
  
  if (partita.read() == NOERR)
  {    
    // se si e' specificato un codice pagamento diverso si rifa' da capo       
    if (pag.code() != partita.get("CODPAG"))
      fromscratch = TRUE;                                       
    // se invece la maschera contiene importi diversi da quelli
    // registrati si passa la palla al culano
    else if (imponibile != partita.get_real(PART_IMPORTO) || 
             imposta    != partita.get_real(PART_IMPOSTA) ||
             spese      != partita.get_real(PART_SPESE))  
    {
      fromscratch = !yesno_box("Gli importi totali delle scadenze sono stati modificati rispetto"
                               " all'ultima registrazione. Si desidera mantenere"
                               " comunque la rateazione precedente");
      // nel caso, of course, si disabilitano gli automatismi
      if(!fromscratch) m.field(FS_RECALC).set("");
    }
    if (fromscratch)
      pag.set_rate_auto();
    else
    {    
      pag.zap_rate();

      for (int i = 0; ; i++)
      { 
        // cerca rata            
        scadenza.zero();
//        scadenza.put("TIPOCF",     tipocf);
//        scadenza.put("GRUPPO",     gruppo);
//        scadenza.put("CONTO",      conto);
//        scadenza.put("SOTTOCONTO", sottoconto);
        scadenza.put(PART_ANNO,    anno);
        scadenza.put(PART_NUMPART, numpart);
        scadenza.put(PART_NRATA,   i+1);
        
        if (scadenza.read() == NOERR)
        {
          const real  importo = scadenza.get(SCAD_IMPORTO); 
          const TDate scad    = scadenza.get(SCAD_DATASCAD);
          const int tipop     = scadenza.get_int(SCAD_TIPOPAG);     
          const bool paid     = scadenza.get_bool(SCAD_PAGATA);
          const TString16 ulc = scadenza.get(SCAD_ULTCLASS);
          pag.set_rata(i, importo, scad, tipop, ulc, paid);
        } 
        else break; 
      } // for
    } //else
  }
  else
    return FALSE;

  pag.set_sheet(ps);
  _pag_rows = ps.rows_array();

  // se la prima rata e' fissa non si tocca
  if (pag.tipo_prima_rata() > 0)
    ps.disable_cell(0,-1);
  
  return TRUE;
}

void TPrimanota_application::write_scadenze(const TMask& m)
{                                                                  
  real imponibile(0.0);   
  real imposta(0.0);   
  real spese(0.0);        

  // should never happen but it doesn't hurt
  CHECK(!_rel->cg(0).empty(), "Missing first line"); 

  TLocalisamfile partita (LF_PARTITE);
  TLocalisamfile scadenza(LF_SCADENZE);
  
  TRectype& r = _rel->lfile().curr();
  
  TString nreg(r.get("NUMREG"));
  TString ndoc(r.get("NUMDOC"));
  TString tmov(r.get("TIPOMOV"));
  TDate   ddoc(r.get_date("DATADOC"));
  TDate   dreg(r.get_date("DATAREG"));                                    
  TString reg (r.get("REG"));       
  TString desc(r.get("DESCR"));
  TString protiva(r.get("PROTIVA")); 
  TString codcaus(r.get("CODCAUS")); 
  TString codval (r.get("CODVAL")); 
  TString cambio (r.get("CAMBIO")); 
  
  TString numpart = m.get(F_NUMRIF);
  const int anno  = m.get_int(F_ANNORIF);
  
  char sezione    = _rel->cg(0).get_char("SEZIONE"); // Dare/Avere
  char tipocf     = _rel->cg(0).get_char("TIPOC"); // Cliente || Fornitore || Uncazzo
  int  gruppo     = (tipocf == 'C' || tipocf == 'F') ? 0 :  _rel->cg(0).get_char("GRUPPO");
  int  conto      = (tipocf == 'C' || tipocf == 'F') ? 0 :  _rel->cg(0).get_char("CONTO");
  long sottoconto = _rel->cg(0).get_long("SOTTOCONTO");
  int  nriga      = 1;
  int  numrig     = 1;
  
//  partita.put("TIPOCF",     tipocf);
//  partita.put("GRUPPO",     gruppo);
//  partita.put("CONTO",      conto);
//  partita.put("SOTTOCONTO", sottoconto);
  partita.put("ANNO",       anno);
  partita.put("NUMPART",    numpart);
  partita.put("NRIGA",      nriga);
  
  bool fromscratch = FALSE, new_part = TRUE;
  
  TPagamento& pag = pagamento();
  
  if (partita.read() == NOERR)
  {    
    // se si e' specificato un codice pagamento diverso si rifa' da capo       
    if (pag.code() != partita.get("CODPAG"))
      fromscratch = TRUE; 
    new_part = FALSE;                                      
  } 
  
  // riaggiusta partite e scadenze
  if (new_part) 
  {
    partita.zero(); 
    partita.put("TIPOCF",     tipocf);
    partita.put("GRUPPO",     gruppo);
    partita.put("CONTO",      conto);
    partita.put("SOTTOCONTO", sottoconto);
    partita.put("ANNO",       anno);
    partita.put("NUMPART",    numpart);
    partita.put("NRIGA",      nriga);
  }   

  // put data on partita
  partita.put("TIPOMOV",tmov);
  partita.put("NREG",   nreg);
  partita.put("DATAREG",dreg); 
  partita.put("DATADOC",ddoc);
  partita.put("REG",    reg);
  partita.put("DESCR",  desc);
  partita.put("PROTIVA",protiva);
  partita.put("CODCAUS",codcaus);
  partita.put("SEZ",    sezione);
  partita.put("CODPAG", pag.code());
  partita.put("CODVAL", codval);
  partita.put("CAMBIO", cambio);
  partita.put("IMPORTO",pag.imponibile());
  partita.put("IMPOSTA",pag.imposta());
  partita.put("SPESE",  pag.spese());
  partita.put("NUMRIG", numrig);
      
  if (new_part) partita.write(); 
  else          partita.rewrite();
      
  bool new_scad = FALSE;
      
  for (int i = 0; i < pag.n_rate(); i++)
  {  
    new_scad = FALSE;
    scadenza.zero();         
//    scadenza.put("TIPOCF",     tipocf);
//    scadenza.put("GRUPPO",     gruppo);
//    scadenza.put("CONTO",      conto);
//    scadenza.put("SOTTOCONTO", sottoconto);
    scadenza.put("ANNO",       anno);
    scadenza.put("NUMPART",    numpart);
    scadenza.put("NRATA",      i+1);
  
    if (scadenza.read() != NOERR)
    {   
      new_scad = TRUE;
      scadenza.zero();
      scadenza.put("TIPOCF",     tipocf);
      scadenza.put("GRUPPO",     gruppo);
      scadenza.put("CONTO",      conto);
      scadenza.put("SOTTOCONTO", sottoconto);
      scadenza.put("ANNO",       anno);
      scadenza.put("NUMPART",    numpart);
      scadenza.put("NRATA",      i+1);
    }
    // set everything 
    scadenza.put("CODPAG",    pag.code());
    scadenza.put("TIPOPAG",   pag.tipo_rata(i));
    scadenza.put("ULTCLASS",  pag.ulc_rata(i));
    scadenza.put("IMPORTO",   pag.tpay_rata(i));
    scadenza.put("DATASCAD",  pag.data_rata(i));
    scadenza.put("PAGATA",    pag.ratapagata(i));
        
    if (new_scad) scadenza.write();
    else          scadenza.rewrite();
  }

  // elimina eventuali altre scadenze oltre l'ultima registrata
  for (; !new_scad ; i++)
  {  
    scadenza.zero();
//      scadenza.put("TIPOCF",     tipocf);
//      scadenza.put("GRUPPO",     gruppo);
//      scadenza.put("CONTO",      conto);
//      scadenza.put("SOTTOCONTO", sottoconto);
    scadenza.put("ANNO",       anno);
    scadenza.put("NUMPART",    numpart);
    scadenza.put("NRATA",      i+1);
      
    if (scadenza.read() == NOERR)
      scadenza.remove();
    else new_scad = TRUE;
  }
}


///////////////////////////////////////////////////////////
// Sheet partite
///////////////////////////////////////////////////////////

bool TPrimanota_application::edit_partite(const TBill& b)
{                                   
  begin_wait();

  TString80 caption("Partite aperte del conto "); 
  caption << b.gruppo() << ' '  << b.conto() << ' ' << b.sottoconto();
  
  TArray_sheet a(-1, -1, 0, 0, caption, "Anno|Numero@7|Descrizione@50|Importo@15R|Sezione");

  TLocalisamfile partita(LF_PARTITE);
  partita.setkey(2);                    // Chiave per conto
  
  partita.zero();          
  if (b.tipo() != ' ')                  // Ignora gruppo e conto dei clifo
  {
    partita.put(PART_TIPOCF, b.tipo());             
    partita.put(PART_SOTTOCONTO, b.sottoconto()); 
  }
  else b.put(partita.curr());           // Scrive completamente i conti normali

  TRectype recpar(partita.curr());   // Record campione

  int ult, anno;                   // Anno ultima partita
  TString16 last, num;                  // Ultimo numero partita e numero corrente         
  TString desc;                         // Descrizione prima partita del gruppo
  TImporto saldo;                       // Saldo ultima parita
  TToken_string r(80);
  
  for (int err = partita.read(_isgteq); err == NOERR && partita.curr() == recpar; err = partita.next())
  {
    num = partita.get(PART_NUMPART);
    anno = partita.get_int(PART_ANNO);
    if (num == last && anno == ult)     // Se la partita e' la stessa ...
    {               
      const TImporto i(partita.get_char(PART_SEZ), partita.get_real(PART_IMPORTO));
      saldo += i;                       // ... incrementa totale
    }
    else
    {           
      if (!saldo.is_zero())             // Se il saldo non e' nullo allora e' aperta
      {
        r.cut(0);
        r.add(ult); r.add(last); r.add(desc); 
        r.add(saldo.valore().string(".")); r.add(saldo.sezione());
        a.add(r);                       // Aggiunge partita alla lista
      }
      ult  = anno;
      last = num;
      desc = partita.get(PART_DESCR);
      saldo.set(partita.get_char(PART_SEZ), partita.get_real(PART_IMPORTO));
    }
  }
  
  if (!saldo.is_zero())            // Aggiunge ultima partita se aperta
  {
    r.cut(0);
    r.add(ult); r.add(last); r.add(desc); 
    r.add(saldo.valore().string(".")); r.add(saldo.sezione());
    a.add(r);
  }
  
  end_wait();
  
  const KEY k = a.items() > 0 ? a.run() : K_ESC;
  if (k != K_ENTER) 
    return FALSE;
  
  anno = a.row().get_int(0);
  num  = a.row().get(1);
  
  TMask m("cg2100s");
  m.set(S_ANNO, anno);
  m.set(S_NUM, num);
  
  TSheet_field& s = (TSheet_field&)m.field(S_SCADENZE);
  TString_array& sr = s.rows_array();
  
  TLocalisamfile scadenza(LF_SCADENZE);
  scadenza.zero(); scadenza.put(SCAD_ANNO, anno); scadenza.put(SCAD_NUMPART, num);
  
  const TRectype recsca(scadenza.curr());
  
  for (err = scadenza.read(_isgteq); 
       err == NOERR && scadenza.curr() == recsca; 
       err = scadenza.next())
  {
    r.cut(0);
    r.add(scadenza.get(SCAD_NRATA));
    r.add(scadenza.get(SCAD_DATASCAD));
    r.add(scadenza.get(SCAD_IMPORTOVAL));
    r.add(scadenza.get(SCAD_IMPORTO));
    r.add("");
    r.add("S");
    sr.add(r);
  }     
  
  partita.setkey(1);
  partita.zero(); partita.put(PART_ANNO, anno); partita.put(PART_NUMPART, num);
  recpar = partita.curr();
  
  const TString16 curreg(curr_mask().get(F_NUMREG));	// Numero registrazione corrente
  desc.cut(0);
  
  for (err = partita.read(_isgteq); err == NOERR && partita.curr() == recpar; err = partita.next())
  {
    const int rata = partita.get_int(PART_NRATA);     // Legge eventuale numero rata
    
    if (desc.empty()) 
    {
      desc = partita.get(PART_DESCR);                 // Aggiorna descrizione scadenze
      for (int i = 0; i < sr.items(); i++) 
      {
        TToken_string& t = sr.row(i);
        if (t.get(S_DESCR-101)[0] <= ' ')
          t.add(desc, S_DESCR-101);
      }    
    }  
    
    if (rata < 1 || partita.get(PART_REG).not_empty()) 
      continue;
    
    for (int i = sr.items()-1; i >= 0; i--)           // Cerca scadenza corrispondente
      if (sr.row(i).get_int(0) == rata) break;

    if (i < 0)
      error_box("Non esiste una scadenza per la rata %d", rata);
    
    r.cut(0);
    r.add(rata);
    r.add(partita.get(PART_DATADOC));
    r.add(partita.get(PART_IMPORTOVAL));
    r.add(partita.get(PART_IMPORTO));
    r.add(desc);
    r.add("P");
    i = sr.insert(r, i >= 0 ? i+1 : -1);
      
    if (partita.get(PART_NREG) != curreg)
      s.disable_cell(i, -1);
  }
  
  s.force_update();
  m.run();
  
  return TRUE;
}
